/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-mavros-extras-0.8.6-0quantal-20150909-1218/msg/OpticalFlow.msg
 *
 */


#ifndef MAVROS_EXTRAS_MESSAGE_OPTICALFLOW_H
#define MAVROS_EXTRAS_MESSAGE_OPTICALFLOW_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace mavros_extras
{
template <class ContainerAllocator>
struct OpticalFlow_
{
  typedef OpticalFlow_<ContainerAllocator> Type;

  OpticalFlow_()
    : header()
    , flow_x(0)
    , flow_y(0)
    , flow_comp_m_x(0.0)
    , flow_comp_m_y(0.0)
    , quality(0)
    , ground_distance(0.0)  {
    }
  OpticalFlow_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , flow_x(0)
    , flow_y(0)
    , flow_comp_m_x(0.0)
    , flow_comp_m_y(0.0)
    , quality(0)
    , ground_distance(0.0)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef int16_t _flow_x_type;
  _flow_x_type flow_x;

   typedef int16_t _flow_y_type;
  _flow_y_type flow_y;

   typedef double _flow_comp_m_x_type;
  _flow_comp_m_x_type flow_comp_m_x;

   typedef double _flow_comp_m_y_type;
  _flow_comp_m_y_type flow_comp_m_y;

   typedef uint8_t _quality_type;
  _quality_type quality;

   typedef double _ground_distance_type;
  _ground_distance_type ground_distance;




  typedef boost::shared_ptr< ::mavros_extras::OpticalFlow_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mavros_extras::OpticalFlow_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpticalFlow_

typedef ::mavros_extras::OpticalFlow_<std::allocator<void> > OpticalFlow;

typedef boost::shared_ptr< ::mavros_extras::OpticalFlow > OpticalFlowPtr;
typedef boost::shared_ptr< ::mavros_extras::OpticalFlow const> OpticalFlowConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mavros_extras::OpticalFlow_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mavros_extras::OpticalFlow_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mavros_extras

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'mavros': ['/opt/ros/hydro/share/mavros/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'mavros_extras': ['/tmp/buildd/ros-hydro-mavros-extras-0.8.6-0quantal-20150909-1218/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mavros_extras::OpticalFlow_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mavros_extras::OpticalFlow_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mavros_extras::OpticalFlow_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cd3dfea8b7fb19a9c34383166b854736";
  }

  static const char* value(const ::mavros_extras::OpticalFlow_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xcd3dfea8b7fb19a9ULL;
  static const uint64_t static_value2 = 0xc34383166b854736ULL;
};

template<class ContainerAllocator>
struct DataType< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mavros_extras/OpticalFlow";
  }

  static const char* value(const ::mavros_extras::OpticalFlow_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# OPTICAL_FLOW message data\n\
\n\
Header header\n\
int16 flow_x\n\
int16 flow_y\n\
float64 flow_comp_m_x\n\
float64 flow_comp_m_y\n\
uint8 quality\n\
float64 ground_distance\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::mavros_extras::OpticalFlow_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.flow_x);
      stream.next(m.flow_y);
      stream.next(m.flow_comp_m_x);
      stream.next(m.flow_comp_m_y);
      stream.next(m.quality);
      stream.next(m.ground_distance);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpticalFlow_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mavros_extras::OpticalFlow_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mavros_extras::OpticalFlow_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "flow_x: ";
    Printer<int16_t>::stream(s, indent + "  ", v.flow_x);
    s << indent << "flow_y: ";
    Printer<int16_t>::stream(s, indent + "  ", v.flow_y);
    s << indent << "flow_comp_m_x: ";
    Printer<double>::stream(s, indent + "  ", v.flow_comp_m_x);
    s << indent << "flow_comp_m_y: ";
    Printer<double>::stream(s, indent + "  ", v.flow_comp_m_y);
    s << indent << "quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.quality);
    s << indent << "ground_distance: ";
    Printer<double>::stream(s, indent + "  ", v.ground_distance);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAVROS_EXTRAS_MESSAGE_OPTICALFLOW_H
